/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: _set_tab.c 1.2 90/05/21 $@(#)libc-port:locale/_set_tab.c 1.0 AT&T-UP"

/*
* _set_tab - set _ctype[], _numeric[] to requested locale-based info.
*/
#include "_locale.h"
#include <locale.h>
#include <string.h>
#include <fcntl.h>

extern char  *_C_inmem[], *_inmem[];	

int
_set_tab(loc, cat)
char *loc;
int cat;
{
	unsigned char my_ctype[SZ_TOTAL];
	static char name[2][11] = { "LC_CTYPE", "LC_NUMERIC" };
	static unsigned char *tab[2] = { _ctype, _numeric };
	int size;
	register int fd, ret;

	size = (cat ? SZ_NUMERIC : SZ_TOTAL);
	if ((fd = open(_fullocale(loc, name[cat]), O_RDONLY)) == -1
	   		|| read(fd, (char *)my_ctype, size) != size)  {

		if (strcmp(loc, "C"))
			ret = -1;

		else {			/* Load default C tables */
			switch(cat) {
				case LC_CTYPE:
					(void)memcpy(tab[cat], _C_ctype, size);
					ret = 0;
					break;
				case LC_NUMERIC:
					(void)memcpy(tab[cat], _C_numeric, size);
					ret = 0;
					break;
				default:
					ret -1;
			}
		}
	}
	else {
		(void)memcpy(tab[cat], my_ctype, size);
		ret = 0;
	}
	(void)close(fd);
	return ret;
}
